static char *recvmsg_id=
	"@(#)Copyright (c) KOUNO Takashi -- recvmsg -- ( IPmsg recver soft ) Ver 0.21";

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <limits.h>
#include <netdb.h>
#include <signal.h>
#include <pwd.h>
#include <errno.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>


#define MAILMSG_VERSION "0.21"

#define IPMSG_VERSION		0x001
#define IPMSG_PORT			0x979
/* #define IPMSG_PORT 2000 */
#define IPMSG_REVERSEICON	0x100

/*  command  */
#define IPMSG_NOOPERATION 0x00000000UL

#define IPMSG_BR_ENTRY 0x00000001UL
#define IPMSG_BR_EXIT 0x00000002UL
#define IPMSG_ANSENTRY 0x00000003UL
#define IPMSG_BR_ABSENCE 0x00000004UL

#define IPMSG_BR_ISGETLIST 0x00000010UL
#define IPMSG_OKGETLIST 0x00000011UL
#define IPMSG_GETLIST 0x00000012UL
#define IPMSG_ANSLIST 0x00000013UL
#define IPMSG_BR_ISGETLIST2 0x00000018UL

#define IPMSG_SENDMSG 0x00000020UL
#define IPMSG_RECVMSG 0x00000021UL
#define IPMSG_READMSG 0x00000030UL
#define IPMSG_DELMSG 0x00000031UL

#define IPMSG_GETINFO 0x00000040UL
#define IPMSG_SENDINFO 0x00000041UL

#define IPMSG_GETABSENCEINFO 0x00000050UL
#define IPMSG_SENDABSENCEINFO 0x00000051UL

/*  option for all command  */
#define IPMSG_ABSENCEOPT 0x00000100UL
#define IPMSG_SERVEROPT 0x00000200UL
#define IPMSG_DIALUPOPT 0x00010000UL

/*  option for send command  */
#define IPMSG_SENDCHECKOPT 0x00000100UL
#define IPMSG_SECRETOPT 0x00000200UL
#define IPMSG_BROADCASTOPT 0x00000400UL
#define IPMSG_MULTICASTOPT 0x00000800UL
#define IPMSG_NOPOPUPOPT 0x00001000UL
#define IPMSG_AUTORETOPT 0x00002000UL
#define IPMSG_RETRYOPT 0x00004000UL
#define IPMSG_PASSWORDOPT 0x00008000UL
#define IPMSG_NOLOGOPT 0x00020000UL
#define IPMSG_NEWMUTIOPT 0x00040000UL
#define IPMSG_NOADDLISTOPT 0x00080000UL

#define HOSTLIST_DELIMIT "\a"
#define HOSTLIST_DUMMY "\b"

/*  end of IP Messenger Communication Protocol version 1.0 define  */


#define UDP_BUF 8192
#define MAXBUFLEN 0x2ff
#define DEFAULT_BROADCAST "DEFAULT"
#define RECVMSGBC "/.recvmsgbc"
#define ENV_HOME "HOME"
#define MAXBCNUM 20
#define MAXBCLEN 16
#define MAXSTPACKET 100
#define MAX_RETRY 10

#if !defined(PATH_MAX)
#define PATH_MAX _POSIX_PATH_MAX
#endif

#define GET_MODE(command)	(command & 0x000000ff)
#define GET_OPT(command)	(command & 0x0000ff00)

typedef struct {
    int     format_ver;
    int     packet_no;
    char    msg_user[MAXBUFLEN];
    char    msg_host[MAXBUFLEN];
    int     command;
    char    *extend;
} MSG;

int sender(int sd, char *buf, long addr, int command);
int recver(int sd);
long hosttoaddr(char *target);
int decom_msg(MSG *msg, char *buf);
/* void interrupt_exit(int sig, int code, struct sigcontext *scp, char *addr);*/
void interrupt_exit();
void print_usage(void);

int g_sd;
int g_ipmsg_port = IPMSG_PORT;
int g_broadcast_num = 0;
char g_broadcast[MAXBCNUM][MAXBCLEN];
int g_get_packet_num = 0;
int g_storage_packet[MAXSTPACKET];
int g_nflag = 1;
int g_timer_exit = 0;
int g_finish = 0;

int main(int argc, char *argv[])
{
	int	sd;
	char buf[UDP_BUF];
	struct hostent	*host;
	long addr;
    char* ptr;
    int lp;
    FILE* fp;
    char bcfile[PATH_MAX];

    memset(g_storage_packet, 0, MAXSTPACKET);

	/* ̉ - nCt1ɂ1̃o[W*/
	for( ;argc > 1 && argv[1][0] == '-';argv++,argc-- ){
		switch( argv[1][1] ){
			case '?':
			case 'h':
                print_usage();
				exit(0);
			case 'p':
			case 'P':
				g_ipmsg_port=strtol(&argv[1][2], &ptr, 0);
				printf("PORT %d(%s)\n", g_ipmsg_port, &argv[1][0]);
				if (g_ipmsg_port==0)
				  g_ipmsg_port=IPMSG_PORT;
				break;
			case 'n':
			case 'N':
				g_nflag = 0;
				break;
			case 'e':
			case 'E':
				g_timer_exit = strtol(&argv[1][2], &ptr, 0);
				printf("TIMER EXIT %d(%s)\n", g_timer_exit, &argv[1][0]);
				break;
			default:
				break;
            }
    }

    if (argc>1){
        ptr = argv[1];
    } else {
        strcpy(bcfile, getenv(ENV_HOME));
        strcat(bcfile, RECVMSGBC);
        ptr = bcfile;
    }
    
    g_broadcast_num = 1;
    strcpy(g_broadcast[0], DEFAULT_BROADCAST);
    if (fp = fopen(ptr, "r")){
        for (g_broadcast_num=1; 
             fgets(g_broadcast[g_broadcast_num], MAXBCLEN, fp) && g_broadcast_num < MAXBCNUM;
             g_broadcast_num++){
            g_broadcast[g_broadcast_num][MAXBCLEN-1] = '\0';
        }
        fclose(fp);
    } else {
        fprintf(stderr, "Can't open %s file : ", ptr);
        perror(NULL);
    }


	if ((sd = socket(AF_INET, SOCK_DGRAM, 0)) ==-1){
		perror("Can't create socket\n");
        return 1;
	} else {
        int flag = 1;
        int option, len;
        if (getsockopt(sd, SOL_SOCKET, SO_BROADCAST, (char*)&flag, &len)){
            perror("getsockopt error!");
            return 1;
        }
        if (!flag){
            flag = 1;
            if (setsockopt(sd, SOL_SOCKET, SO_BROADCAST, (char*)&flag, sizeof(int))){
                perror("setsockopt error!");
                return 1;
            }
        }
    }
	
    /* Ctl-C */
    g_sd = sd;
    signal(SIGINT, interrupt_exit);
    /* Timer */
    if (g_timer_exit){
        struct itimerval value;
        signal(SIGALRM, interrupt_exit);

        value.it_interval.tv_sec = g_timer_exit;
        value.it_interval.tv_usec = 0;
        value.it_value.tv_sec = g_timer_exit;
        value.it_value.tv_usec = 0;
        setitimer(ITIMER_REAL, &value, NULL);
    }

	/* M҂ */
	if (!recver(sd)){
		return 1;
	}

    for (lp=0; lp<g_broadcast_num; lp++){
        sender(sd, NULL, hosttoaddr(g_broadcast[lp]), IPMSG_BR_EXIT);
    }
	close( sd );
	return 0;
}

/* Sender */
int sender( int sd, char *buf, long addr, int command )
{
	char msg[UDP_BUF];
    char hostname[MAXBUFLEN];
	static int packet_no;
	struct sockaddr_in	saddr;
	struct hostent		*host;

	memset(&saddr, 0, sizeof(saddr));
	saddr.sin_family		= AF_INET;
	saddr.sin_port			= htons(g_ipmsg_port);
	saddr.sin_addr.s_addr	= addr;

	if (gethostname(hostname, MAXBUFLEN) == -1){
		strcpy(hostname,"Unknow host");
	}

	/* Make Message */
	sprintf(msg, "%d:%d:%s:%s:%d:%s", IPMSG_VERSION, packet_no++, getpwuid(getuid())->pw_name, hostname, command, buf ? buf : "");

	/* Send */
	if (sendto(sd, msg, strlen( msg ) +1, 0, (struct sockaddr *)&saddr, sizeof(saddr)) == -1){
		perror("sendto err");
		return	0;
	}

	return 1;
}

/* zXg -> AhX ϊ */
long hosttoaddr(char *target)
{
	struct sockaddr_in	saddr;
    char hostname[MAXBUFLEN];
	long addr;
	struct hostent *host;

    if (strcmp(target, DEFAULT_BROADCAST) == 0){
        return ~0;
    }

	if ((addr = inet_addr(target)) == -1){
		if ((host = (struct hostent *)gethostbyname(target)) != NULL){
			addr = *(long *)host->h_addr;
		} else {
            fprintf(stderr, "invalid hostname(%s) : ", target);
			perror(NULL);
			return 0;
		}
	}
	return addr;
}

/* Receive Message function */
int recver(int sd)
{
	char buf[UDP_BUF];
	char str[UDP_BUF];
	char message[UDP_BUF]="";
	struct sockaddr_in	saddr;
	MSG msg;
	int flag=1;
	int	size;
	time_t now_time;
	int lp;

	memset(&msg, 0, sizeof(msg));
	size=sizeof(saddr);

	/* bZ[W{̗p̗̈m */
	if ( (msg.extend=malloc(UDP_BUF)) == NULL){
		perror("Message memory allocate error!\n");
		return 0;
	}
    msg.extend[0] = '\0';

	/* sockaddr_in\̂̐ݒ */
	memset((char *)&saddr, 0, size );
	saddr.sin_family		= AF_INET;
	saddr.sin_port			= htons(g_ipmsg_port);
	saddr.sin_addr.s_addr	= htonl(INADDR_ANY);

	/* \PbgoCh */
    for (lp=0; 1; lp++){
        if (bind(sd, (struct sockaddr *)&saddr, sizeof(saddr)) == -1){
            if (errno == EADDRINUSE && lp<MAX_RETRY){
                sleep(2);
            } else {
                fprintf(stderr, "Bind error %d port\n", g_ipmsg_port);
                perror(NULL);
                return 0;
            }
        } else {
            break;
        }
    }


	/* Gg[ʒm */
    for (lp=0; lp<g_broadcast_num; lp++){
        if (!sender(sd, NULL, hosttoaddr(g_broadcast[lp]), IPMSG_BR_ENTRY)){
            return 0;
        }
    }

	while(flag){
        /* tJn */
        if (g_finish){
            break;
        }
		if (recvfrom(sd, buf, UDP_BUF, 0, (struct sockaddr *)&saddr, &size) == -1){
            perror("recv error");
			return 0;
		}

		if ( !decom_msg(&msg, buf ) ){
			continue;
		}
		
		/* R}h̔ */
		switch(GET_MODE(msg.command)){
        case IPMSG_BR_ENTRY:
            if ( !sender(sd, NULL, saddr.sin_addr.s_addr, IPMSG_ANSENTRY)){
                return 0;
            }
            /* ʂ蔲` */
        case IPMSG_ANSENTRY:
        	if (g_nflag){
	            fprintf(stdout, "Entry (%s@%s[%s])\n", msg.msg_user, msg.msg_host, inet_ntoa(saddr.sin_addr));
	        }
            break;
            
        case IPMSG_BR_EXIT:
        	if (g_nflag){
	            fprintf(stdout, "Exit (%s@%s[%s])\n", msg.msg_user, msg.msg_host, inet_ntoa(saddr.sin_addr));
	        }
            break;
			
        case IPMSG_RECVMSG:
            fprintf(stdout, "%s@%s 烁bZ[W̎MmF󂯎܂\n" , msg.msg_user, msg.msg_host);
            break;
			
        case IPMSG_READMSG:
            fprintf(stdout, "%s@%s 烁bZ[W̊JmF󂯂Ƃ܂\n", msg.msg_user, msg.msg_host);
            break;

        case IPMSG_SENDMSG:
            time( &now_time );
            printf( "----------------------------------------------\n" );
            
            /* M`FbN */
            if (GET_OPT(msg.command) & IPMSG_SENDCHECKOPT){
                sprintf(buf, "%d", msg.packet_no);
                if (!sender( sd, buf, hosttoaddr(msg.msg_host), IPMSG_RECVMSG)){
                    return 0;
                }
            }
            if (GET_OPT(msg.command) & IPMSG_SECRETOPT){
                sprintf(buf, "%d", msg.packet_no);
                if (!sender( sd, buf, hosttoaddr(msg.msg_host), IPMSG_READMSG)){
                    return 0;
                }
            }
				
            /* u[hLXg */
            if (GET_OPT(msg.command) & IPMSG_BROADCASTOPT){
                printf( "      Broadcast from %s ( %s )\n", 
                       msg.msg_user, msg.msg_host );
            } else {				
				/* }`LXg */
				if (GET_OPT(msg.command) & IPMSG_MULTICASTOPT){
                    printf( "      Multicast from %s ( %s )\n", 
                           msg.msg_user, msg.msg_host );
				} else {
					printf( "      Message from %s ( %s )\n", 
                           msg.msg_user, msg.msg_host );
				}
            }
            printf( "      at %s", ctime( &now_time )  );
            printf( "----------------------------------------------\n" );
            printf( "%s\n", msg.extend);
            printf( "----------------Message End-------------------\n\n" );
            if (strcmp(msg.extend, "quit\n") ==0){
                return 1;
            }
            break;
		}
        fflush(stdout);
	}
	return 1;
}

int decom_msg( MSG *msg, char *buf )
{
	char *str;
	
	/* Get format version */
	if ((str=strchr( buf,':')) == NULL){
		fprintf(stderr, "Can't find format version\n" );
		return 0;
	}
	str[0]='\0';
	if ((msg->format_ver=atoi(buf)) != IPMSG_VERSION){
		return 0;
	}
	buf=str+1;
	
	/* Get Packet No */
	if ((str=strchr(buf, ':')) == NULL){
		fprintf(stderr, "Can't find Packet\n");
		return 0;
	}
	str[0]='\0';
	msg->packet_no=atoi( buf ) ;
	buf=str+1;
	
	/* Get Sender Name */
	if ((str=strchr(buf, ':')) == NULL){
		fprintf(stderr, "Can't find Sender Name\n" );
		return 0;
	}
	str[0]='\0';
	strcpy( msg->msg_user, buf );
	buf=str+1;
	
	/* Get Sendhost Name */
	if ((str=strchr(buf,':')) == NULL){
		fprintf(stderr, "Can't find Sendhost Name\n" );
		return 0;
	}
	str[0]='\0';
	strcpy( msg->msg_host, buf );
	buf=str+1;
	
	/* Get command */
	if ((str=strchr(buf,':')) == NULL){
		fprintf(stderr, "Can't find command\n" );
		return 0;
	}
	str[0]='\0';
	msg->command=atoi(buf) ;
	buf=str+1;
	
	/* Get Extension */
	strcpy(msg->extend, buf);
	buf=str+1;
	
	return 1;
}

/* void interrupt_exit(int sig, int code, struct sigcontext *scp, char *addr)*/
void interrupt_exit()
{
    int lp;
    for (lp=0; lp<g_broadcast_num; lp++){
        sender(g_sd, NULL, hosttoaddr(g_broadcast[lp]), IPMSG_BR_EXIT);
    }
    g_finish = 1;
}

void print_usage()
{
    printf("resvmsg ver.%s - IPMSG recever tool\n", MAILMSG_VERSION);
}
